export default (req, res, error, page, redirectTo) => {
  if (error) {
    res.status(500);
    return res.render('index', {
      pagename: '500',
      viewname: '500',
      page: {
        title: '500: Oups… le serveur a crashé !',
        error,
      },
      baseUrl: '',
      params: {},
      query: {},
      user: req.user || null,
      error,
    });
  }

  if (redirectTo) {
    return res.redirect(redirectTo);
  }

  return res.render('index', page.render());
};
