import express from 'express';
import {ensureLoggedIn} from 'connect-ensure-login';
import Uploads from '../middleware/Uploads';
import render from '../libs/Render';

// eslint-disable-next-line new-cap
const router = express.Router();

router.route('/').get(ensureLoggedIn('/connexion'), (req, res) => {
  return res.redirect('/upload');
});

router
    .route('/upload')
    .get(ensureLoggedIn('/connexion'), (req, res) => {
      const page = new Uploads(req, 'upload');
      return render(req, res, null, page);
    })
    .post(ensureLoggedIn('/connexion'), async (req, res, next) => {
      try {
        const page = new Uploads(req, 'upload');

        await page.postOne(req);

        render(req, res, null, page);
      } catch (err) {
        next(err);
      }
    });

router.route('/gallery')
    .get(ensureLoggedIn('/connexion'), async (req, res, next) => {
      try {
        const page = new Uploads(req, 'gallery');

        await page.getAll(req);

        render(req, res, null, page);
      } catch (err) {
        next(err);
      }
    });

export default router;
